ctdb-scripts: Quote some variable expansions
[nivanova/samba-autobuild/.git] / ctdb / config / events.d / 60.nfs
index 4d5494a9a86913f4edc5717130e27d4c0fe951f5..249b22621794e47d83b9de5bf72e2a75c79aa1fa 100755 (executable)
 #!/bin/sh
 # script to manage nfs in a clustered environment
 
-start_nfs() {
-       /bin/mkdir -p $CTDB_BASE/state/nfs
-       /bin/mkdir -p $CTDB_BASE/state/statd/ip
-       /bin/mkdir -p $STATD_SHARED_DIRECTORY
-       startstop_nfs stop
-       startstop_nfs start
+[ -n "$CTDB_BASE" ] || \
+    CTDB_BASE=$(d=$(dirname "$0") ; cd -P "$d" ; dirname "$PWD")
+
+. "${CTDB_BASE}/functions"
+
+service_name="nfs"
+loadconfig
+ctdb_setup_service_state_dir
+
+######################################################################
+
+service_reconfigure ()
+{
+    # Restart lock manager, notify clients
+    if [ -x "${CTDB_BASE}/statd-callout" ] ; then
+       "${CTDB_BASE}/statd-callout" notify &
+    fi >/dev/null 2>&1
 }
 
-reconfigure_nfs() {
-       # always restart the lockmanager so that we start with a clusterwide
-       # graceperiod when ip addresses has changed
-       [ -x $CTDB_BASE/statd-callout ] && {
-               $CTDB_BASE/statd-callout notify &
-       } >/dev/null 2>&1
+######################################################################
+
+######################################################
+# Check the health of NFS services
+#
+# Use .check files in $CTDB_NFS_CHECKS_DIR.
+# Default is "${CTDB_BASE}/nfs-checks.d/"
+######################################################
+nfs_check_services ()
+{
+    _dir="${CTDB_NFS_CHECKS_DIR:-${CTDB_BASE}/nfs-checks.d}"
 
+    # Files must end with .check - avoids editor backups, RPM fu, ...
+    for _f in "$_dir"/[0-9][0-9].*.check ; do
+       _t="${_f%.check}"
+       _progname="${_t##*/[0-9][0-9].}"
+
+       nfs_check_service "$_progname" <"$_f"
+    done
 }
 
-. $CTDB_BASE/functions
+######################################################
+# Check the health of an NFS service
+#
+# $1 - progname, passed to rpcinfo (looked up in /etc/rpc)
+#
+# Reads variables from stdin
+#
+# Variables are:
+#
+# * family             - "tcp" or "udp" or space separated list
+#                        default: tcp, not used with "service_check_cmd"
+# * version            - optional, RPC service version number
+#                        default is to omit to check for any version,
+#                        not used with "service_check_cmd"
+# * unhealthy_after    - number of check fails before unhealthy
+#                        default: 1
+# * restart_every      - number of check fails before restart
+#                        default: 0, meaning no restart
+# * service_stop_cmd   - command to stop service
+#                        default: no default, must be provided if
+#                                 restart_every > 0
+# * service_start_cmd  - command to start service
+#                        default: no default, must be provided if
+#                                 restart_every > 0
+# * service_check_cmd  - command to check health of service
+#                        default is to check RPC service using rpcinfo
+# * service_debug_cmd  - command to debug a service after trying to stop it;
+#                        for example, it can be useful to print stack
+#                        traces of threads that have not exited, since
+#                        they may be stuck doing I/O;
+#                        no default, see also function program_stack_traces()
+#
+# Quoting in values is not preserved
+#
+######################################################
+nfs_check_service ()
+{
+    _progname="$1"
 
-service_name="nfs"
-service_start="start_nfs"
-service_stop="startstop_nfs stop"
-service_reconfigure="reconfigure_nfs"
+    (
+       # Subshell to restrict scope variables...
 
-loadconfig
+       # Defaults
+       family="tcp"
+       version=""
+       unhealthy_after=1
+       restart_every=0
+       service_stop_cmd=""
+       service_start_cmd=""
+       service_check_cmd=""
+       service_debug_cmd=""
+
+       # Eval line-by-line.  Expands variable references in values.
+       # Also allows variable name checking, which seems useful.
+       while read _line ; do
+           case "$_line" in
+               \#*|"") : ;; # Ignore comments, blank lines
+
+               family=*|version=*|\
+               unhealthy_after=*|restart_every=*|\
+               service_stop_cmd=*|service_start_cmd=*|\
+               service_check_cmd=*|service_debug_cmd=*)
+
+                   eval "$_line"
+                   ;;
+               *)
+                   echo "ERROR: Unknown variable for ${_progname}: ${_line}"
+                   exit 1
+           esac
+       done
 
-[ -z "$STATD_SHARED_DIRECTORY" ] && exit 0
+       _service_name="nfs_${_progname}"
+
+       _ok=false
+       if [ -n "$service_check_cmd" ] ; then
+           # Using eval means variables can contain semicolon separated commands
+           if eval "$service_check_cmd" ; then
+               _ok=true
+           else
+               _err="monitoring service \"${_progname}\" failed"
+           fi
+       else
+           if nfs_check_rpcinfo \
+                  "$_progname" "$version" "$family" >/dev/null ; then
+               _ok=true
+           else
+               _err="$ctdb_check_rpc_out"
+           fi
+       fi
+
+       if $_ok ; then
+           if [ $unhealthy_after -ne 1 -o $restart_every -ne 0 ] ; then
+               ctdb_counter_init "$_service_name"
+           fi
+           exit 0
+       fi
+
+       ctdb_counter_incr "$_service_name"
+       _failcount=$(ctdb_counter_get "$_service_name")
+
+       _unhealthy=false
+       if [ $unhealthy_after -gt 0 ] ; then
+           if [ $_failcount -ge $unhealthy_after ] ; then
+               _unhealthy=true
+               echo "ERROR: $_err"
+           fi
+       fi
+
+       if [ $restart_every -gt 0 ] ; then
+           if [ $(($_failcount % $restart_every)) -eq 0 ] ; then
+               if ! $_unhealthy ; then
+                   echo "WARNING: $_err"
+               fi
+               nfs_restart_service
+           fi
+       fi
+
+       if $_unhealthy ; then
+           exit 1
+       fi
+
+       return 0
+    ) || exit 1
+}
+
+# Uses: stop_service, start_service, debug_stuck_threads
+nfs_restart_service ()
+{
+    if [ -z "$service_stop_cmd" -o -z "$service_start_cmd" ] ; then
+       die "ERROR: Can not restart service \"${_progname}\" without corresponding service_start_cmd/service_stop_cmd settings"
+    fi
+
+    echo "Trying to restart service \"${_progname}\"..."
+    # Using eval means variables can contain semicolon separated commands
+    eval "$service_stop_cmd"
+    if [ -n "$service_debug_cmd" ] ; then
+       eval "$service_debug_cmd"
+    fi
+    background_with_logging eval "$service_start_cmd"
+}
+
+######################################################
+# Check an RPC service with rpcinfo
+######################################################
+ctdb_check_rpc ()
+{
+    _progname="$1"        # passed to rpcinfo (looked up in /etc/rpc)
+    _version="$2"         # optional, not passed if empty/unset
+    _family="${3:-tcp}"   # optional, default is "tcp"
+
+    case "$_family" in
+       tcp6|udp6)
+           _localhost="${CTDB_RPCINFO_LOCALHOST6:-::1}"
+           ;;
+       *)
+           _localhost="${CTDB_RPCINFO_LOCALHOST:-127.0.0.1}"
+    esac
+
+    if ! ctdb_check_rpc_out=$(rpcinfo -T "$_family" "$_localhost" \
+                                     "$_progname" $_version 2>&1) ; then
+       ctdb_check_rpc_out="$_progname failed RPC check:
+$ctdb_check_rpc_out"
+       echo "$ctdb_check_rpc_out"
+       return 1
+    fi
+}
+
+nfs_check_rpcinfo ()
+{
+    _progname="$1"        # passed to rpcinfo (looked up in /etc/rpc)
+    _versions="$2"        # optional, space separated, not passed if empty/unset
+    _families="${3:-tcp}" # optional, space separated, default is "tcp"
+
+    for _family in $_families ; do
+       if [ -n "$_versions" ] ; then
+           for _version in $_versions ; do
+               ctdb_check_rpc "$_progname" "$_version" "$_family" || return $?
+           done
+       else
+           ctdb_check_rpc "$_progname" "" "$_family" || return $?
+       fi
+    done
+}
+
+##################################################################
+# use statd-callout to update NFS lock info
+##################################################################
+nfs_update_lock_info ()
+{
+    if [ -x "$CTDB_BASE/statd-callout" ] ; then
+       "$CTDB_BASE/statd-callout" update
+    fi
+}
+
+######################################################################
+
+nfs_callout_init
 
 ctdb_start_stop_service
 
-case "$1" in 
-     startup)
-       ctdb_service_start
+is_ctdb_managed_service || exit 0
+
+ctdb_service_check_reconfigure
+
+case "$1" in
+    startup)
+       nfs_callout "$@"
        ;;
 
-     shutdown)
-       ctdb_service_stop
+    shutdown)
+        nfs_callout "$@"
        ;;
 
-     takeip)
+    takeip)
+       nfs_callout "$@"
        ctdb_service_set_reconfigure
-       touch $CTDB_BASE/state/statd/ip/$3
        ;;
 
-     releaseip)
+    releaseip)
+       nfs_callout "$@"
        ctdb_service_set_reconfigure
-       /bin/rm -f $CTDB_BASE/state/statd/ip/$3
        ;;
 
-     recovered)
-       # if we have taken or released any ips we must 
-       # restart the lock manager so that we enter a clusterwide grace period
-       if ctdb_service_needs_reconfigure ; then
-           ctdb_service_reconfigure
-       fi
-       ;;
+    monitor)
+       nfs_callout "monitor-pre" || exit $?
 
-      monitor)
-       if ctdb_service_needs_reconfigure ; then
-           ctdb_service_reconfigure
-           exit 0
+       # Check that directories for shares actually exist
+       if [ "$CTDB_NFS_SKIP_SHARE_CHECK" != "yes" ] ; then
+           nfs_callout "monitor-list-shares" | ctdb_check_directories || \
+               exit $?
        fi
 
-       # check that statd responds to rpc requests
-       # if statd is not running we try to restart it
-       rpcinfo -u localhost 100024 1 > /dev/null || {
-               RPCSTATDOPTS=""
-               [ -n "$STATD_HOSTNAME" ] && RPCSTATDOPTS="$RPCSTATDOPTS -n $STATD_HOSTNAME"
-               [ -n "$STATD_PORT" ] && RPCSTATDOPTS="$RPCSTATDOPTS -p $STATD_PORT"
-               [ -n "$STATD_OUTGOING_PORT" ] && RPCSTATDOPTS="$RPCSTATDOPTS -o $STATD_OUTGOING_PORT"
-               rpc.statd $RPCSTATDOPTS 
-               echo "ERROR: STATD is not responding. Trying to restart it. [rpc.statd $RPCSTATDOPTS]"
-       }
-
-
-       # check that NFS responds to rpc requests
-       ctdb_check_rpc "NFS" 100003 3
-
-       # and that its directories are available
-       [ "$CTDB_NFS_SKIP_SHARE_CHECK" = "yes" ] || {
-           exportfs | grep -v '^#' | grep '^/' |
-           sed -e 's/[[:space:]]*[^[:space:]]*$//' |
-           ctdb_check_directories
-       } || exit $?
-
-       # check that lockd responds to rpc requests
-       ctdb_check_rpc "lockd" 100021 1
-       echo "$STATD_SHARED_DIRECTORY" | ctdb_check_directories "statd" || \
-           exit $?
-
-       # mount needs special handling since it is sometimes not started
-       # correctly on RHEL5
-       rpcinfo -u localhost 100005 1 > /dev/null || {
-               echo "ERROR: MOUNTD is not running. Trying to restart it."
-               RPCMOUNTDOPTS=""
-               [ -n "$MOUNTD_PORT" ] && RPCMOUNTDOPTS="$RPCMOUNTDOPTS -p $MOUNTD_PORT"
-               killall -q -9 rpc.mountd
-               rpc.mountd $RPCMOUNTDOPTS &
-               exit 1
-       }
+       update_tickles 2049
+       nfs_update_lock_info
+
+       nfs_check_services
+
+       nfs_callout "monitor-post" || exit $?
                ;;
 
     *)